JUCE

- Main Page
- Related Pages
- Topics
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Loading...
Searching...
No Matches
Public Member Functions | List of all members
BufferedInputStream Class Reference
juce_core » streams

Wraps another input stream, and reads from it using an intermediate buffer. More...

`#include <juce_BufferedInputStream.h>`

Inheritance diagram for BufferedInputStream:

## Public Member Functions
| BufferedInputStream (InputStream *sourceStream, int bufferSize, bool deleteSourceWhenDestroyed)
| Creates a BufferedInputStream from an input source.
| BufferedInputStream (InputStream &sourceStream, int bufferSize)
| Creates a BufferedInputStream from an input source.
| ~BufferedInputStream () override
| Destructor.
char | peekByte ()
| Returns the next byte that would be read by a call to readByte()
int64 | getTotalLength () override
| Returns the total number of bytes available for reading in this stream.
int64 | getPosition () override
| Returns the offset of the next byte that will be read from the stream.
bool | setPosition (int64 newPosition) override
| Tries to move the current read position of the stream.
int | read (void *destBuffer, int maxBytesToRead) override
| Reads some data from the stream into a memory buffer.
String | readString () override
| Reads a zero-terminated UTF-8 string from the stream.
bool | isExhausted () override
| Returns true if the stream has no more data to read.
Public Member Functions inherited from InputStream
virtual | ~InputStream ()=default
| Destructor.
int64 | getNumBytesRemaining ()
| Returns the number of bytes available for reading, or a negative value if the remaining length is not known.
ssize_t | read (void *destBuffer, size_t maxBytesToRead)
virtual char | readByte ()
| Reads a byte from the stream.
virtual bool | readBool ()
| Reads a boolean from the stream.
virtual short | readShort ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual short | readShortBigEndian ()
| Reads two bytes from the stream as a little-endian 16-bit value.
virtual int | readInt ()
| Reads four bytes from the stream as a little-endian 32-bit value.
virtual int | readIntBigEndian ()
| Reads four bytes from the stream as a big-endian 32-bit value.
virtual int64 | readInt64 ()
| Reads eight bytes from the stream as a little-endian 64-bit value.
virtual int64 | readInt64BigEndian ()
| Reads eight bytes from the stream as a big-endian 64-bit value.
virtual float | readFloat ()
| Reads four bytes as a 32-bit floating point value.
virtual float | readFloatBigEndian ()
| Reads four bytes as a 32-bit floating point value.
virtual double | readDouble ()
| Reads eight bytes as a 64-bit floating point value.
virtual double | readDoubleBigEndian ()
| Reads eight bytes as a 64-bit floating point value.
virtual int | readCompressedInt ()
| Reads an encoded 32-bit number from the stream using a space-saving compressed format.
virtual String | readNextLine ()
| Reads a UTF-8 string from the stream, up to the next linefeed or carriage return.
virtual String | readEntireStreamAsString ()
| Tries to read the whole stream and turn it into a string.
virtual size_t | readIntoMemoryBlock (MemoryBlock &destBlock, ssize_t maxNumBytesToRead=-1)
| Reads from the stream and appends the data to a MemoryBlock.
virtual void | skipNextBytes (int64 numBytesToSkip)
| Reads and discards a number of bytes from the stream.

## Additional Inherited Members
Protected Member Functions inherited from InputStream
| InputStream ()=default

## Detailed Description

Wraps another input stream, and reads from it using an intermediate buffer.

If you're using an input stream such as a file input stream, and making lots of small read accesses to it, it's probably sensible to wrap it in one of these, so that the source stream gets accessed in larger chunk sizes, meaning less work for the underlying stream.

## Constructor & Destructor Documentation

## ◆ BufferedInputStream() [1/2]

BufferedInputStream::BufferedInputStream | ( | InputStream * | sourceStream,
|  | int | bufferSize,
|  | bool | deleteSourceWhenDestroyed )

Creates a BufferedInputStream from an input source.

Parameters

  sourceStream | the source stream to read from
  bufferSize | the size of reservoir to use to buffer the source
  deleteSourceWhenDestroyed | whether the sourceStream that is passed in should be deleted by this object when it is itself deleted.

## ◆ BufferedInputStream() [2/2]

BufferedInputStream::BufferedInputStream | ( | InputStream & | sourceStream,
|  | int | bufferSize )

Creates a BufferedInputStream from an input source.

Parameters

  sourceStream | the source stream to read from - the source stream must not be deleted until this object has been destroyed.
  bufferSize | the size of reservoir to use to buffer the source

## ◆ ~BufferedInputStream()

BufferedInputStream::~BufferedInputStream | ( |  | ) |
| override

Destructor.

This may also delete the source stream, if that option was chosen when the buffered stream was created.

## Member Function Documentation

## ◆ peekByte()

char BufferedInputStream::peekByte | ( |  | ) |

Returns the next byte that would be read by a call to readByte()

## ◆ getTotalLength()

int64 BufferedInputStream::getTotalLength | ( |  | ) |
| override virtual

Returns the total number of bytes available for reading in this stream.

Note that this is the number of bytes available from the start of the stream, not from the current position.

If the size of the stream isn't actually known, this will return -1.

See also
  getNumBytesRemaining

Implements InputStream.

## ◆ getPosition()

int64 BufferedInputStream::getPosition | ( |  | ) |
| override virtual

Returns the offset of the next byte that will be read from the stream.

See also
  setPosition

Implements InputStream.

## ◆ setPosition()

bool BufferedInputStream::setPosition | ( | int64 | newPosition | ) |
| override virtual

Tries to move the current read position of the stream.

The position is an absolute number of bytes from the stream's start.

Some streams might not be able to do this, in which case they should do nothing and return false. Others might be able to manage it by resetting themselves and skipping to the correct position, although this is obviously a bit slow.

Returns
  true if the stream manages to reposition itself correctly

See also
  getPosition

Implements InputStream.

## ◆ read()

int BufferedInputStream::read | ( | void * | destBuffer,
|  | int | maxBytesToRead )
| override virtual

Reads some data from the stream into a memory buffer.

This is the only read method that subclasses actually need to implement, as the InputStream base class implements the other read methods in terms of this one (although it's often more efficient for subclasses to implement them directly).

Parameters

  destBuffer | the destination buffer for the data. This must not be null.
  maxBytesToRead | the maximum number of bytes to read - make sure the memory block passed in is big enough to contain this many bytes. This value must not be negative.

Returns
  the actual number of bytes that were read, which may be less than maxBytesToRead if the stream is exhausted before it gets that far

Implements InputStream.

## ◆ readString()

String BufferedInputStream::readString | ( |  | ) |
| override virtual

Reads a zero-terminated UTF-8 string from the stream.

This will read characters from the stream until it hits a null character or end-of-stream.

See also
  OutputStream::writeString, readEntireStreamAsString

Reimplemented from InputStream.

## ◆ isExhausted()

bool BufferedInputStream::isExhausted | ( |  | ) |
| override virtual

Returns true if the stream has no more data to read.

Implements InputStream.

The documentation for this class was generated from the following file:

- juce_BufferedInputStream.h